config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  mount LetterOpenerWeb::Engine, at: "/letter_opener" if Rails.env.development?

  devise_for :users, path: 'accounts', controllers: { registrations: 'users/registrations'}

  devise_scope :user do
    authenticated :user do
      root 'user_records#index'
    end

    unauthenticated do
      root 'devise/sessions#new', as: :unauthenticated_root
    end
  end

  resources :medical_histories, except: [:show, :destroy] do
    collection do
      get :add_attribute
    end
  end
  resources :personal_data, except: [:show, :destroy] do
    collection do
      get :add_attribute
    end
  end

  resources :users, only: [:show]
  resources :user_records, only: [:index, :show, :edit, :update, :destroy] do
    member do
      post :view
      get :view
      get :share
      post :share
      get :share_form
      get :edit_data
      post :edit_data
    end
    resources :share_keys
  end

end

app/models/user_record.rb
class UserRecord < ApplicationRecord
    extend Enumerize

    has_one_attached :file, dependent: :destroy
    has_many :share_keys, dependent: :destroy
    has_many :access_logs
    belongs_to :user

    validates_presence_of :encrypted_file_key, :encrypted_cipher_key, :encrypted_cipher_iv, :phr_type

    enumerize :phr_type, in: [:medical_history, :personal_data], i18n_scope: "phr_types", scope: true, predicates: true

    def read_file(user = nil, args = {})
        password = args[:password]
        downloader = FileDownloader.new(self, user)
        output = downloader.process(password)
        if downloader.errors.any?
            downloader.errors.each do |error|
                errors.add(:base, error)
            end
        end
        return output
    end

    def edit_file(user = nil, args = {})
        password = args[:password]
        downloader = FileDownloader.new(self, user)
        output = downloader.process(password, false)
        if downloader.errors.any?
            downloader.errors.each do |error|
                errors.add(:base, error)
            end
        end
        return output
    end

    def share_file(owner = nil, args = {})
        password = args[:password]
        share_recipient = args[:share_recipient]
        sharer = FileSharer.new(self, owner, share_recipient)
        status = sharer.process(password)
        if sharer.errors.any?
            sharer.errors.each do |error|
                errors.add(:base, error)
            end
        end
        return status
    end
    
    def is_owner?(user = nil)
        return false if user.nil?
        self.user == User.find(user.id)
    end

    def has_access?(user = nil)
        return false if user.nil?
        self.share_keys.exists?(user: user) || is_owner?(user)
    end
end

app/controllers/user_records_controller.rb
class UserRecordsController < ApplicationController
    before_action :set_user_record, only: [:show, :view, :destroy, :edit, :share, :share_form, :edit_data]

    def index
        owned_user_records = current_user.user_records.to_a || []
        @user_records = owned_user_records + current_user.records_with_access.to_a
    end

    def show
        if @user_record.is_owner?(current_user)
            @share_keys = @user_record.share_keys
            @access_logs = @user_record.access_logs.includes(:user)
        end
    end

    def view
        if request.post?
            output = @user_record.read_file(current_user, user_record_params)
            if @user_record.errors.empty?
                send_data(output.force_encoding('BINARY'), type: 'application/pdf', disposition: 'inline')
            else
                redirect_to user_record_path(@user_record), error: @user_record.errors.full_messages
            end
        else
            redirect_to user_record_path(@user_record), information: "Please enter your password"
        end
    end

    def destroy
        @user_record.destroy
        redirect_to root_path
    end

    def share_form
    end

    def share
        if request.post?
            share_recipient = share_user_record_params[:share_recipient]
            status = @user_record.share_file(current_user, share_user_record_params)
            if status
                redirect_to share_form_user_record_path(@user_record), success: "Successfully shared record to #{share_recipient}"
            else
                flash[:error] = @user_record.errors.full_messages
                render :share_form
            end
        else
            redirect_to share_form_user_record_path(@user_record)
        end
    end

    def edit
    end

    def edit_data
        if request.post?
            @output = @user_record.edit_file(current_user, user_record_params)
            if @user_record.errors.any?
                redirect_to edit_user_record_path(@user_record), error: @user_record.errors.full_messages
            end
        else
            redirect_to edit_user_record_path(@user_record), information: "Please enter your password"
        end
    end

    def update
        @user_record = UserRecord.find(params[:id])
        if params.has_key?(:medical_history)
            params[:medical_history].merge!({owner_id: current_user.id})
            @output = MedicalHistory.new(medical_history_params)
            status = @output.update(@user_record)
        elsif params.has_key?(:personal_data)
            params[:personal_data].merge!({owner_id: current_user.id})
            @output = PersonalData.new(personal_data_params)
            status = @output.update(@user_record)
        else
            flash[:error] = "You can't update a record to an empty record."
            @output = if @user_record.phr_type == 'medical_history'
                MedicalHistory.new
            elsif
                PersonalData.new
            else
                nil
            end
                
            render :edit_data and return if @output.present?
            redirect_to edit_user_record_path(@user_record), error: "You're updating an invalid record"
        end
        
        if status
            redirect_to user_record_path(@user_record), success: "PHR updated successfully."
        else
            flash[:error] = ["Please check the data you provided."]
            render :edit_data
        end
    end
    
    private

    def set_user_record
        user_record = UserRecord.find(params[:id])
        if user_record.has_access?(current_user)
            @user_record = UserRecord.find(params[:id])
        else
            redirect_to root_path, warning: 'You do not have permission to access that record'
        end
    end
    
    def user_record_params
        params.require(:user_record).permit(:password)
    end

    def share_user_record_params
        params.require(:user_record).permit(:password, :share_recipient)
    end
    
    def medical_history_params
        params.require(:medical_history).permit(:owner_id, :password,
            allergies_attributes: Allergy::ATTRIBUTES,
            vaccinations_attributes: Vaccination::ATTRIBUTES,
            health_conditions_attributes: HealthCondition::ATTRIBUTES,
            medications_attributes: Medication::ATTRIBUTES
        )
    end

    def personal_data_params
        params.require(:personal_data).permit(:owner_id, :password,
            personal_demographics_attributes: PersonalDemographics::ATTRIBUTES,
            emergency_contacts_attributes: EmergencyContact::ATTRIBUTES,
            insurances_attributes: Insurance::ATTRIBUTES
        )
    end
end

app/helpers/user_records_helper.rb
module UserRecordsHelper
end

app/views/user_records/_access_history.html.haml
.ui.centered.grid
    .vertical.center.aligned.column
        .ui.segment
            %h3.ui.header Access History
            .ui.segment
                - if history.present?
                    %table.ui.celled.striped.table
                        %thead
                            %tr
                                %th Name
                                %th Access ID
                                %th Accessed on
                        %tbody
                            - history.each do |item|
                                %tr
                                    %td= item.user.fullname
                                    %td= item.id
                                    %td= item.created_at.localtime.strftime("%b %d, %Y %T %:z")
                - else
                    = render 'shared/empty_placeholder', object: 'access_history'

app/views/user_records/_invalid.html.haml
%h2.text-center Invalid Personal Health Record

app/views/user_records/_share_keys.html.haml
.vertical.center.aligned.eight.wide.column
    .ui.segment
        %h3.ui.header Share Keys
        .ui.segment
            - if share_keys.present?
                %table.ui.celled.striped.table
                    %thead
                        %tr
                            %th Name
                            %th Email
                            %th Actions
                    %tbody
                        - share_keys.each do |share_key|
                            %tr
                                %td= share_key.user.fullname
                                %td= share_key.user.email
                                %td
                                    = link_to user_record_share_key_path(record, share_key), title: 'Delete Share Key', remote: true, method: :delete, data: {confirm: "Are you sure you want to remove this share key?"} do
                                        %i.trash.icon
            - else
                = render 'shared/empty_placeholder', object: 'share_key'

app/views/user_records/edit.html.haml
.column
    .ui.vertical.center.aligned.segment
        .ui.huge.header.center.aligned
            = "Edit #{t("phr_types.#{@user_record.phr_type}")}"
        .ui.centered.grid
            .vertical.center.aligned.eight.wide.column
                .ui.left.aligned.segment
                    .ui.relaxed.horizontal.divided.list
                        .item
                            .content
                                .header
                                    = link_to user_record_path(@user_record) do
                                        = @user_record.id
                                User Record ID
                        .item
                            .content
                                .header
                                    = link_to user_path(@user_record.user) do
                                        = @user_record.user.fullname
                                Owner Name
                = form_tag edit_data_user_record_path(@user_record), method: :post, class: 'ui form' do
                    .field
                        = label :password, :password, 'Enter password to edit record'
                        = password_field_tag 'user_record[password]', nil
                    .field
                        = submit_tag 'Submit', class: 'ui primary button fluid'

app/views/user_records/edit_data.html.haml
- if @user_record.phr_type.present?
    - phr_type = @user_record.phr_type
    = render "#{phr_type.pluralize}/edit", content: @output, user_record: @user_record

app/views/user_records/index.html.haml
.column
    .ui.vertical.center.aligned.segment
        .ui.huge.header.center.aligned All Records
        = link_to 'New Medical History', new_medical_history_path, class: 'ui olive button'
        = link_to 'Edit Profile', edit_user_registration_path, class: 'ui brown button'
        = link_to 'New Personal Data', new_personal_data_path, class: 'ui teal button'
        
        - if @user_records.any?
            = render 'shared/items', user_records: @user_records
        - else
            = render 'shared/empty_placeholder', object: 'record'

app/views/user_records/share_form.html.haml
.column
    .ui.vertical.center.aligned.segment
        .ui.huge.dividing.header.center.aligned
            = "Share #{t("phr_types.#{@user_record.phr_type}")}"
        .ui.centered.grid
            .vertical.center.aligned.eight.wide.column
                .ui.left.aligned.segment
                    .ui.relaxed.horizontal.divided.list
                        .item
                            .content
                                .header
                                    = link_to user_record_path(@user_record) do
                                        = @user_record.id
                                User Record ID
                        .item
                            .content
                                .header
                                    = link_to user_path(@user_record.user) do
                                        = @user_record.user.fullname
                                Owner Name
                .ui.left.aligned.segment
                    = form_tag share_user_record_path(@user_record), method: :post, class: 'ui form' do
                        .field.required
                            = label :share_recipient, :share_recipient, 'Recipient'
                            = text_field_tag 'user_record[share_recipient]', @user_record.try(:share_recipient), placeholder: 'Enter email address of recipient (that has a confirmed account)'
                        .field.required
                            = label :password, :password, 'Your Password'
                            = password_field_tag 'user_record[password]', nil, placeholder: 'Enter password to share record'
                            .hint
                                Your password will not be used by the recipient 
                        .field
                            = submit_tag 'Submit', class: 'ui primary fluid button'
            = render 'share_keys', share_keys: @user_record.share_keys, record: @user_record

app/views/user_records/show.html.haml
.column
    .ui.vertical.center.aligned.segment
        .ui.huge.dividing.header
            = "#{t("phr_types.#{@user_record.phr_type}")} of #{@user_record.user.fullname}"
        .ui.centered.grid
            .vertical.center.aligned.eight.wide.column
                .ui.segment
                    %h3.ui.header View Record
                    .ui.segment
                        = form_tag view_user_record_path(@user_record), method: :post, class: 'ui form' do
                            .field
                                = label :user_record, :password, 'Enter password to view record'
                                = password_field_tag 'user_record[password]', nil
                            .field
                                = submit_tag 'Submit', class: 'ui primary button'
            - if @user_record.is_owner?(current_user)
                .vertical.center.aligned.four.wide.column
                    .container
                        .ui.vertical.segment
                            = link_to edit_user_record_path(@user_record), class: 'ui blue labeled icon button' do
                                Edit Record
                                %i.edit.right.icon
                        .ui.vertical.segment
                            = link_to user_record_path(@user_record), method: :delete, class: 'ui red labeled icon button' do
                                Delete Record
                                %i.trash.right.icon
                        .ui.vertical.segment
                            = link_to share_form_user_record_path(@user_record), class: 'ui teal labeled icon button' do
                                Share Record
                                %i.share.right.icon
        - if @user_record.is_owner?(current_user)
            = render 'access_history', history: @access_logs

app/views/user_records/view.html.haml
- phr_type = user_record.phr_type
%h2.title.has-text-centered
    = "#{t("phr_types.#{phr_type}")} of #{user_record.user.fullname}"
.box
    .ui.container
        - if phr_type.present?
            = render "#{phr_type.pluralize}/view", content: content
        - else
            = render 'invalid', content: content
%footer.footer
    .content.has-text-centered
        .list
            .list-item
                This PDF is created on
                = Time.now
            .list-item
                Access ID: 
                = access_id    